econfig_sbmixrate =     44100           ; set mixingrate to max

                align   4
sd_envstring    db      256 dup(0)

;͸͸
; Sd_EnvConfig                                                              
;ľ                                            
;                                                                            
; In:  -                                                                     
;                                                                            
; Out: -                                                                     
;                                                                            
; Description: Get configuration from environment variables                  
;                                                                            
;ľ
;  
                align   4
sd_envconfig:   pushad

                mov     [sd_cardtype],6

                call    sd_envconfig_us
                jnc     @@card_found

                call    sd_envconfig_sb
                jnc     @@card_found

@@card_found:   popad
                ret

                align   4
sd_envconfig_us:mov     edx,offset us_envvar
                mov     ebx,offset sd_envstring
                call    sd_getenvvar
                jc      @@no_env

                add     ebx,8
                sub     ecx,ecx
                mov     al,[ebx+1]
                and     al,0fh
                or      cl,al
                shl     ecx,4
                mov     al,[ebx+2]
                and     al,0fh
                or      cl,al
                shl     ecx,4
                mov     al,[ebx+3]
                and     al,0fh
                or      cl,al
                mov     [sd_base],cx
                mov     [us_base],cx

                call    us_detect
                jc      @@no_env

                mov     [sd_cardtype],1
                clc
                ret
@@no_env:       stc
                ret

                align   4
sd_envconfig_sb:mov     edx,offset sb_envvar
                mov     ebx,offset sd_envstring
                call    sd_getenvvar
                jc      @@no_env

                add     ebx,7
                mov     edx,ebx
                mov     al,'A'
@@address:      inc     ebx
                cmp     [ebx],al
                jne     @@address
                mov     al,[ebx+1]
                and     al,0fh
                sub     ecx,ecx
                mov     cl,al
                mov     al,[ebx+2]
                and     ax,0fh
                shl     ecx,4
                or      cx,ax
                mov     al,[ebx+3]
                and     ax,0fh
                shl     ecx,4
                or      cx,ax
                mov     [sd_base],cx
                mov     [sb_base],cx

                mov     ebx,edx
                mov     al,'I'
@@irq:          inc     ebx
                cmp     [ebx],al
                jne     @@irq
                mov     al,[ebx+1]
                and     ax,0fh
                mov     [sd_irq],ax
                mov     [sb_irq],ax

                mov     ebx,edx
                mov     al,'D'
@@dma:          inc     ebx
                cmp     [ebx],al
                jne     @@dma
                mov     al,[ebx+1]
                and     ax,0fh
                mov     [sd_dma],ax
                mov     [sb_dma],ax

                mov     [sd_mixrate],econfig_mixrate
                mov     [sb_mixrate],econfig_mixrate

                call    sb_detect
                jc      @@no_env

                call    sb_getdspver

                cmp     ax,300h
                jge     @@sbpro
                cmp     ax,201h
                je      @@sb20
                cmp     ax,200h
                je      @@sb15

@@sb10:         mov     [sd_cardtype],5
                clc
                ret

@@sb15:         mov     [sd_cardtype],4
                clc
                ret

@@sb20:         mov     [sd_cardtype],3
                clc
                ret

@@sbpro:        mov     [sd_cardtype],2
                clc
                ret

@@no_env:       stc
                ret

;͸͸
; Sd_GetEnvVar                                                                      
;ľ                                                    
;                                                                                    
; In:  edx - Evironment Variable                                                     
;      ebx - Address to copy the variable defined at edx  (256 bytes long string)    
;                                                                                    
; Out: [edx] - Environment string                                                    
;                                                                                    
; Description: Copies wanted envronment string to buffer                             
;                                                                                    
;ľ
;  
                align   4
sd_getenvvar:   pushad
                mov     esi,[_pspa]
                sub     esi,[_code32a]
                movzx   esi,[word esi+2ch]
                shl     esi,4
                sub     esi,[_code32a]
                mov     ebp,7fffh
@@env_loop:     cmp     [byte esi],0
                jz      @@no_env
                call    @@compare
                jnc     @@env_found
@@env_null:     dec     ebp
                jz      @@no_env
                inc     esi
                cmp     [byte esi],0
                jne     @@env_null
                inc     esi
                jmp     @@env_loop
                jmp     @@no_env
@@compare:      sub     edi,edi
@@compare_loop: mov     al,[edx+edi]
                test    al,al
                jz      @@compare_done
                cmp     al,[esi+edi]
                jne     @@compare_failed
                inc     edi
                jmp     @@compare_loop
@@compare_failed:
                stc
                ret
@@compare_done: clc
                ret
@@no_env:       popad
                stc
                ret
@@env_found:    cmp     [byte esi+edi],'='
                jne     @@no_env
                sub     ecx,ecx
@@env_copy:     mov     al,[esi]
                mov     [ebx],al
                inc     esi
                inc     ebx
                inc     ecx
                test    al,al
                jnz     @@env_copy
                popad
                clc
                ret
