;
; example of use #1
;
; intializes music, starts playing and shows row information on screen
;

ideal
locals
p386
public          _main

include         "pmode\pmode.inc"
include         "sdrss.inc"
include         "plays3m.inc"

extrn           scamel : near

segment         code32  para public use32
                assume  cs:code32, ds:code32

                align   4
_main:          sti

                mov     [v86r_ax],0f00h
                mov     ax,10h
                int     33h

                movzx   ax,[v86r_al]
                mov     [oldscreenmode],ax

                mov     ax,3
                call    sync

                ; initialize sound device
                call    sd_initialize

                mov     eax,offset scamel
                mov     [module],eax

                ; initialize music routine
                call    initmusic
                jc      @@error1

                ; start playing
                call    startmusic

                mov     eax,offset playing_msg
                call    displaymsg

@@wait_esc:     call    waitretrace
                call    displayrow
                in      al,60h
                cmp     al,1
                jne     @@wait_esc

                ; stop playing
                call    stopmusic

                ; uninitialize sounddevice
                call    sd_uninitialize

                mov     ax,[oldscreenmode]
                call    sync

                jmp     _exit

@@error1:       mov     eax,offset errormsg
                call    displaymsg
                jmp     _exit

                align 4
waitretrace:    mov     dx,3dah
@@active:       in      al,dx
                test    al,8
                jnz      @@active
@@inactive:     in      al,dx
                test    al,8
                jz      @@inactive
                ret

                align   4
displaymsg:     add     eax,[_code32a]
                shld    ebx,eax,28
                and     eax,0fh
                mov     [v86r_ds],bx
                mov     [v86r_dx],ax
                mov     [v86r_ah],9
                mov     al,21h
                int     33h
                ret

                align   4
sync:           pushad
                mov     [v86r_ax],ax
                mov     ax,10h
                int     33h
                popad
                ret

oldscreenmode   dw      ?
playing_msg     db      'Playing - press ESC to stop.$',0
errormsg        db      'Error!$',0

                align   4
displayrow:     pushad
                call    @@notes
                call    @@insts
                call    @@volume
                call    @@command
                call    @@cinfo
                popad
                ret

@@notes:        mov     ebx,0b8000h
                sub     ebx,[_code32a]
                add     ebx,160*10

                mov     esi,offset row_note
                mov     ecx,8

@@notes_chans:  sub     eax,eax
                mov     al,[esi]
                cmp     al,255
                jne     @@noemptynote
                mov     ax,124
@@noemptynote:  cmp     al,254
                jne     @@nokeyoff
                mov     ax,125
@@nokeyoff:     lea     eax,[eax*2+notelist]
                mov     dl,[eax]
                mov     [ebx],dl
                mov     dl,[eax+1]
                mov     [ebx+2],dl
                mov     [byte ebx+1],1
                mov     [byte ebx+3],1
                add     ebx,20
                inc     esi
                dec     ecx
                jnz     @@notes_chans
                ret

@@insts:        mov     ebx,0b8000h
                sub     ebx,[_code32a]
                add     ebx,160*10+4

                mov     esi,offset row_instrument
                mov     ecx,8

@@insts_chans:  sub     eax,eax
                mov     al,[esi]

                test    al,al
                je      @@no_inst

                mov     dl,al
                and     eax,0fh
                mov     al,[@@hextab+eax]
                shr     dl,4
                and     edx,0fh
                mov     dl,[@@hextab+edx]
                mov     [byte ebx+1],2
                mov     [byte ebx+3],2
                mov     [ebx],dl
                mov     [ebx+2],al
                add     ebx,20
                inc     esi

                dec     ecx
                jnz     @@insts_chans
                ret

@@no_inst:      mov     [byte ebx],'.'
                mov     [byte ebx+2],'.'

                add     ebx,20
                inc     esi
                dec     ecx
                jnz     @@insts_chans
                ret

@@volume:       mov     ebx,0b8000h
                sub     ebx,[_code32a]
                add     ebx,160*10+8

                mov     esi,offset row_volume
                mov     ecx,8

@@volume_chans: sub     eax,eax
                mov     al,[esi]

                cmp     al,0ffh
                je      @@no_vol

                mov     dl,al
                and     eax,0fh
                mov     al,[@@hextab+eax]
                shr     dl,4
                and     edx,0fh
                mov     dl,[@@hextab+edx]
                mov     [ebx],dl
                mov     [ebx+2],al
                mov     [byte ebx+1],3
                mov     [byte ebx+3],3

                add     ebx,20
                inc     esi
                dec     ecx
                jnz     @@volume_chans
                ret

@@no_vol:       mov     [byte ebx],'.'
                mov     [byte ebx+2],'.'

                add     ebx,20
                inc     esi
                dec     ecx
                jnz     @@volume_chans
                ret

@@command:      mov     ebx,0b8000h
                sub     ebx,[_code32a]
                add     ebx,160*10+12

                mov     esi,offset row_command
                mov     ecx,8
@@loop:         mov     al,[esi]
                cmp     al,255
                je      @@empty_com
                add     al,'A'-1
                mov     [ebx],al
                mov     [byte ebx+1],4
                add     ebx,20
                inc     esi
                dec     ecx
                jnz     @@loop
                ret
@@empty_com:    mov     [byte ebx],'.'
                mov     [byte ebx+1],4
                add     ebx,20
                inc     esi
                dec     ecx
                jnz     @@loop
                ret

@@cinfo:        mov     ebx,0b8000h
                sub     ebx,[_code32a]
                add     ebx,160*10+14

                mov     esi,offset row_cinfo
                mov     ecx,8

@@cinfo_chans:  sub     eax,eax
                mov     al,[esi]

                cmp     al,0
                je      @@no_cinfo

                mov     dl,al
                and     eax,0fh
                mov     al,[@@hextab+eax]
                shr     dl,4
                and     edx,0fh
                mov     dl,[@@hextab+edx]
                mov     [ebx],dl
                mov     [ebx+2],al
                mov     [byte ebx+1],4
                mov     [byte ebx+3],4

                add     ebx,20
                inc     esi
                dec     ecx
                jnz     @@cinfo_chans
                ret
@@no_cinfo:     mov     [byte ebx],'.'
                mov     [byte ebx+2],'.'
                mov     [byte ebx+1],4
                mov     [byte ebx+3],4
                add     ebx,20
                inc     esi
                dec     ecx
                jnz     @@cinfo_chans
                ret

@@hextab        db      '0123456789ABCDEF'


notelist        db      'C0','c0','D0','d0','E0','F0','f0','G0','g0','A0','a0','B0'
                db      4*2 dup (?)
                db      'C1','c1','D1','d1','E1','F1','f1','G1','g1','A1','a1','B1'
                db      4*2 dup (?)
                db      'C2','c2','D2','d2','E2','F2','f2','G2','g2','A2','a2','B2'
                db      4*2 dup(?)
                db      'C3','c3','D3','d3','E3','F3','f3','G3','g3','A3','a3','B3'
                db      4*2 dup (?)
                db      'C4','c4','D4','d4','E4','F4','f4','G4','g4','A4','a4','B4'
                db      4*2 dup (?)
                db      'C5','c5','D5','d5','E5','F5','f5','G5','g5','A5','a5','B5'
                db      4*2 dup (?)
                db      'C6','c6','D6','d6','E6','F6','f6','G6','g6','A6','a6','B6'
                db      4*2 dup (?)
                db      'C7','c7','D7','d7','E7','F7','f7','G7','g7','A7','a7','B7'
                db      '..','^^'


ends            code32
end
