;
;               Copyright (c)1995 Juha Pohto
;
;
; Filename   : SETUP.ASM
; Author     : Juha Pohto
; Date       : 950611
; Description: Write configuration to disk
; Version    : 1.01
;
; 1.01 - ESC bug fixed
;

ideal
locals
p386
public          _main

include         "pmode\pmode.inc"

segment         code32  para public use32
                assume  cs:code32, ds:code32

                align   4
label           sd_config
sd_cardtype     dd      ?                                               ; 0
sd_base         dw      ?                                               ; 4
sd_irq          dw      ?                                               ; 6
sd_dma          dw      ?                                               ; 8
sd_mixrate      dd      ?                                               ; 10
                db      "Slender's Sound System configuration file."    ; 14

                align   4
_main:          sti

                call    sd_getconfig
                call    saveconfig

                jmp     _exit

                align   4
saveconfig:     mov     edx,offset @@filename
                call    _createfile
                mov     edx,offset sd_config
                mov     ecx,56
                call    _writefile
                call    _closefile
                ret

@@filename      db      "sdrss.cfg",0


include         "gconfig.asm"

;
; ripped from FILE.ASM
;

masm
;
; DATA
;
_filebufloc     dd      0               ; location must be in low mem
_filebuflen     dw      1000h

;
; CODE
;

;
; Create file
; In:
;   EDX -> ASCIIZ filename
; Out:
;   CF=1 - Error creating file
;   CF=0 - File created succesfully
;     V86R_BX - file handle
;
_createfile:
        push ax
        push edx
        add edx,_code32a
        mov ax,dx
        shr edx,4
        and ax,0fh
        mov v86r_dx,ax
        mov v86r_ds,dx
        mov v86r_ax,3c00h
        mov v86r_cx,20h
        mov al,21h
        int 33h
        mov ax,v86r_ax
        mov v86r_bx,ax
        pop edx
        pop ax
        ret

;
; Close a file
; In:
;   V86R_BX - file handle
;   CF=1 - Error closing file
;   CF=0 - File closed succesfully
;
_closefile:
        push ax
        mov v86r_ax,3e00h
        mov al,21h
        int 33h
        pop ax
        ret

;
; Write to file
; In:
;   V86R_BX - file handle
;   EDX -> buffer to write from
;   ECX - number of bytes to write
; Out:
;   CF=1 - Error writing file
;     EAX - ?
;   CF=0 - Write went fine
;     EAX - number of bytes written
;
_writefile:
        pushad
        xor ebp,ebp
        add edx,_code32a
        lea ebx,[ecx+edx]
        cmp ebx,100000h
        ja writelong
        mov eax,edx
        shr edx,4
        and ax,0fh
        mov v86r_ds,dx
        mov v86r_dx,ax
writel:
        mov eax,0fff0h
        cmp eax,ecx
        jbe writelf1
        mov eax,ecx
writelf1:
        mov v86r_cx,ax
        mov v86r_ax,4000h
        mov al,21h
        int 33h
        jc writedone2
        movzx ebx,v86r_ax
        add ebp,ebx
        sub ecx,ebx
        jbe writedone
        add v86r_ds,0fffh
        jmp writel
writelong:
        mov esi,edx
        sub esi,_code32a
        mov edx,ecx
        mov eax,_filebufloc
        add eax,_code32a
        mov ebx,eax
        shr eax,4
        and bx,0fh
        mov v86r_ds,ax
        mov v86r_dx,bx
        movzx ebx,_filebuflen
writelongl:
        mov eax,ebx
        cmp eax,edx
        jbe writelonglf1
        mov eax,edx
writelonglf1:
        mov ecx,eax
        mov edi,_filebufloc
        rep movsb
        mov v86r_cx,ax
        mov v86r_ax,4000h
        mov al,21h
        int 33h
        jc writedone2
        movzx ecx,v86r_ax
        add ebp,ecx
        sub edx,ecx
        ja writelongl
writedone:
        clc
writedone2:
        mov [esp+28],ebp
        popad
        ret
ideal

ends            code32
end
